import random

class Ball:
    def __init__(self, canvas, paddle, color):
        self.canvas = canvas
        self.paddle = paddle
        self.id     = canvas.create_oval(10, 10, 25, 25, fill = color)

        self.canvas.move(self.id, 245, 100)

        startXList = [-3, -2, -1, 1, 2, 3]

        random.shuffle(startXList)

        self.x             = startXList[0]
        self.y             = -3
        self.canvas_height = self.canvas.winfo_height()
        self.canvas_width  = self.canvas.winfo_width()
        self.hitBottom     = False
        
    def draw(self):
        self.canvas.move(self.id, self.x, self.y)

        position = self.canvas.coords(self.id)

        if position[1] <= 0:
            self.y = 3

        if self.hitPaddle(position) == True:
            self.y = -3

        if position[3] >= self.canvas_height:
            self.hitBottom = True

        if position[0] <= 0:
            self.x = 3

        if position[2] >= self.canvas_width:
            self.x = -3
            
    def hitPaddle(self, position):
        paddle_pos = self.canvas.coords(self.paddle.id)

        if position[2] >= paddle_pos[0] and position[0] <= paddle_pos[2]:
            if position[3] >= paddle_pos[1] and position[3] <= paddle_pos[3]:
                return True

        return False